#include <stdio.h>
#include <stdlib.h>

#define WIDTH 3000;    //Dimensionen des Bildes
#define HEIGHT 2100;

int w = WIDTH;
int h = HEIGHT;

int main() {
  int i,j,x,y,col;
  
  FILE *f;
  unsigned char *img = NULL;
  int filesize = 54 + 3*w*h;  
  if( img ) free( img );
  img = (unsigned char *)malloc(3*w*h);
  memset(img,0,sizeof(img));

  for(i=0; i<w; i++)
  {
    for(j=0; j<h; j++)
    {
      x=i; y=(h-1)-j;
      if ((j>1000)&&(j<1010)) col=0; else col=255; 
      img[(x+y*w)*3+2] = (unsigned char)(col);   // Hier kommen die Pixel (255, 0 ,0 bedeutet alles rot)
      img[(x+y*w)*3+1] = (unsigned char)(col);
      img[(x+y*w)*3+0] = (unsigned char)(col);
    }
  }

  unsigned char bmpfileheader[14] = {'B','M', 0,0,0,0, 0,0, 0,0, 54,0,0,0};
  unsigned char bmpinfoheader[40] = {40,0,0,0, 0,0,0,0, 0,0,0,0, 1,0, 24,0};   // 24 bit Farbtiefe
  unsigned char bmppad[3] = {0,0,0};

  bmpfileheader[ 2] = (unsigned char)(filesize    );
  bmpfileheader[ 3] = (unsigned char)(filesize>> 8);
  bmpfileheader[ 4] = (unsigned char)(filesize>>16);
  bmpfileheader[ 5] = (unsigned char)(filesize>>24);

  bmpinfoheader[ 4] = (unsigned char)(       w    );
  bmpinfoheader[ 5] = (unsigned char)(       w>> 8);
  bmpinfoheader[ 6] = (unsigned char)(       w>>16);
  bmpinfoheader[ 7] = (unsigned char)(       w>>24);
  bmpinfoheader[ 8] = (unsigned char)(       h    );
  bmpinfoheader[ 9] = (unsigned char)(       h>> 8);
  bmpinfoheader[10] = (unsigned char)(       h>>16);
  bmpinfoheader[11] = (unsigned char)(       h>>24);

  f = fopen("img_24.bmp","wb");
  fwrite(bmpfileheader,1,14,f);
  fwrite(bmpinfoheader,1,40,f);
  for(i=0; i<h; i++)
  {
    fwrite(img+(w*(h-i-1)*3),3,w,f);
    fwrite(bmppad,1,(4-(w*3)%4)%4,f);
  }
  fclose(f);
}
